/* --- Copyright University of Birmingham 1996. All rights reserved. ------
 > File:            $poplocal/local/auto/rc_circle.p
 > Purpose:         Draw a circle
 > Author:          Aaron Sloman, Apr  4 1996
 > Documentation:	rc_circle(x,y,radius)
 > Related Files:
 */


/*
rc_start();
rc_circle(0,0,100);
rc_circle(100,0,100);
rc_circle(0,100,100);
rc_circle(-50,-50,100);
rc_circle(0,-50,100);
rc_circle(50,-50,100);

-0.5 -> rc_yscale;
0.5 -> rc_xscale;
-1 -> rc_yscale; 1 -> rc_xscale;
and then redo

*/

compile_mode :pop11 +strict;
section;

uses rc_graphic;

define rc_circle(xcentre, ycentre, radius);
	lconstant fullcirc = 360*64;	;;; units are 1/64 degree
	rc_transxyout(xcentre,ycentre) ->(xcentre,ycentre);
	lvars diam = radius+radius;

	XpwDrawArc(rc_window,
		round(xcentre - rc_xscale * radius),
		round(ycentre + rc_yscale * radius),
		round(abs(diam*rc_xscale)),
		round(abs(diam*rc_yscale)),
		0,
		fullcirc);
enddefine;


endsection;

/* --- Revision History ---------------------------------------------------
--- Aaron Sloman, Apr 12 1996
    Fixed scaling bug. Switched to use XpwDrawArc directly
 */
