/* --- The University of Birmingham 1994.  --------------------------------
 > File:            $poplocal/local/auto/ved_arrows.p
 > Purpose:         Convert arrow keys to do small moves
 > Author:          Aaron Sloman, Sep 29 1994
 > Documentation: 	below
 > Related Files:	LIB VEDNCDXTERMKEYS
 */

/*
LIB VED_ARROWS                                     A.Sloman 29 Sept 1994

For some reason some of the terminals that should transmit different
codes when the arrow keys are pressed and when the 2 4 6 8 keypad
keys are pressed do not do so: they all default to the arrow keys which
are normally used only for large moves (SCREENDOWN, SCREENUP, etc).

In order to make them produce small cursor movements give the command
	ENTER arrows

Then preceding the arrow keys with ESC will produce larger moves, and
preceding up arrow and down arrow with ESC ESC will go to top or
bottom of file.

*/

define ved_arrows();
	vedset keys
		charup				= esc [ A				;;; UP
		chardown			= esc [ B				;;; DOWN
		charleft			= esc [ D				;;; LEFT
		charright			= esc [ C				;;; RIGHT

		screenup			= esc esc [ A			;;; ESC UP
		screendown			= esc esc [ B			;;; ESC DOWN
		screenleft			= esc esc [ D			;;; ESC LEFT
		textright			= esc esc [ C			;;; ESC RIGHT

		topfile				= esc esc esc [ A		;;; ESC ESC UP
		endfile				= esc esc esc [ B		;;; ESC ESC DOWN

	endvedset;
enddefine;
