/* --- Copyright University of Birmingham 1998. All rights reserved. ------
 > File:			$poplocal/local/auto/vedsuntype5.p
 >					ALTERNATIVE VERSION
 > Purpose:			Extend VED keyboard setup for xterm on a sun
 >						with Type5 keyboard.
 > Author:			Aaron Sloman Wed Jul 21 1993 (see revisions)
 > Documentation:	HELP * VEDXTERM
 > Related Files:	LIB * VEDXTERMKEYS, * VEDSUNXTERMKEYS
 */

;;; compile_mode :pop11 +strict;

section;

uses vedset;

define vedsuntype5();

;;; vedsunxtermkeys();

	vedset keys

		;;; Make the HELP key refresh the screen.
		"xrefresh"          =   esc K               ;;; Help
		"ENTER hkey"        =   esc esc K           ;;; ESC Help

		"dotdelete"			=   ^H                  ;;; Back Space

		"linebelow"			=	esc [ 2 3 ~			;;; L1 (F11)
		"lineabove"			=	esc [ 2 4 ~			;;; L2 (F12)
		"pushkey"			=	esc [ 2 5 ~			;;; L3
		"linebelow"			=	esc [ 2 6 ~			;;; L4
		"exchangeposition"	=	esc [ 2 8 ~			;;; L5
		"loadline"			=	esc [ 2 9 ~			;;; L6
		"popkey"			=	esc [ 3 1 ~			;;; L7
		"redokey"			=	esc [ 3 2 ~			;;; L8
		"statusswitch"		=	esc [ 3 3 ~			;;; L9
		"enterkey"			=	esc [ 3 4 ~			;;; L10

		"screenbell"		=	esc esc [ 2 3 ~		;;; ESC L1 (F11)
		"ENTER crm"			=	esc esc [ 2 4 ~		;;; ESC L2 (F12)
		"ENTER break"		=	esc esc [ 2 5 ~		;;; ESC L3
		"xrefresh"			=	esc esc [ 2 6 ~		;;; ESC L4
		"ENTER jp"			=	esc esc [ 2 8 ~		;;; ESC L5
		"setstatic"			=	esc esc [ 2 9 ~		;;; ESC L6
		"ENTER pop"			=	esc esc [ 3 1 ~		;;; ESC L7

		"marklo"			=	esc [ 1 1 ~			;;; F1
		"markhi"			=	esc [ 1 2 ~			;;; F2
		"clearhead"			=	esc [ 1 3 ~			;;; F3
		"linedelete"		=	esc [ 1 4 ~			;;; F4
		"cleartail"			=	esc [ 1 5 ~			;;; F5
		"wordleftdelete"	=	esc [ 1 7 ~			;;; F6
		"wordrightdelete"	=	esc [ 1 8 ~			;;; F7
		"ENTER m"			=	esc [ 1 9 ~			;;; F8
		"ENTER t"			=	esc [ 2 0 ~			;;; F9
		"xrefresh"			= esc [ 2 1 ~			;;; F10
		;;; F11 and F12 duplicate L1 and L2

		"ENTER mbf"			=	esc esc [ 1 1 ~		;;; ESC F1
		"ENTER mef"			=	esc esc [ 1 2 ~		;;; ESC F2
		"ENTER yankw"		=	esc esc [ 1 3 ~		;;; ESC F3
		"ENTER yankl"		=	esc esc [ 1 4 ~		;;; ESC F4
		"ENTER yankw"		=	esc esc [ 1 5 ~		;;; ESC F5
		"ENTER yankw"		=	esc esc [ 1 7 ~		;;; ESC F6
		"ENTER yankw"		=	esc esc [ 1 8 ~		;;; ESC F7
		"ENTER mi"			=	esc esc [ 1 9 ~		;;; ESC F8
		"ENTER ti"			=	esc esc [ 2 0 ~		;;; ESC F9
		"ENTER mo"			=	esc esc [ 2 1 ~		;;; ESC F10
		;;; F11 and F12 duplicate L1 and L2


		;;; Arrow keys in middle keypad
		;;; changed to do small character moves. AS Fri Dec 20 1996
		"charup"			= esc [ A				  ;;; UP
		"chardown"			= esc [ B				  ;;; DOWN
		"charleft"			= esc [ D				  ;;; LEFT
		"charright"			= esc [ C				  ;;; RIGHT

		;;; Big moves with Arrow keys
		"topfile"			= esc esc [ A			  ;;; ESC UP
		"endfile"			= esc esc [ B			  ;;; ESC DOWN
		"textleft"			= esc esc [ D			  ;;; ESC LEFT
		"screenright"		= esc esc [ C			  ;;; ESC RIGHT

		;;; Keys around numeric keypad

		"wordleft"			=   esc O p             ;;; KP 0
		"wordright"			=   esc O n             ;;; KP .
		"enterkey"          =   esc O M             ;;; Enter
		"statusswitch"		=   esc O k             ;;; KP +
		"redokey"           =   esc O m             ;;; KP -
		"redokey"           =   esc [ 1 1 4 ~       ;;; KP -
		"screenbell"        =   esc [ 1 1 0 ~       ;;; NumLock

		;;; The "/" key = R5, and the "*" key = R6

		"textleft"			=   esc [ 1 1 1 ~       ;;; R1  Pause
		"screenup"			=   esc [ 1 1 2 ~       ;;; R2  PrScr & Moon+
		"textright"			=   esc [ 1 1 3 ~       ;;; R3  ScrLock & Moon-
;;;		"screenleft"		=   esc [ 1 1 4 ~       ;;; R4 [!]
		"screendown"		=   esc [ 1 1 5 ~       ;;; R5  "/" and Top Right
		"screenright"		=   esc [ 1 1 7 ~       ;;; R6  "*"
		"charupleft"		=   esc [ 1 1 8 ~       ;;; R7  (7)
		"charup"			=   esc [ 1 1 9 ~		;;; R8  (8)
		"charupright"		=   esc [ 1 2 0 ~       ;;; R9  (9)
		"charleft"			=   esc [ 1 2 1 ~		;;; R10 (4)
		"ENTER timed_esc"	=   esc [ 1 2 3 ~       ;;; R11 (5)
		"charright"			=   esc [ 1 2 4 ~		;;; R12 (6)
		"chardownleft"		=   esc [ 1 2 5 ~       ;;; R13 (1)
		"chardown"			=   esc [ 1 2 6 ~		;;; R14 (2)
		"chardownright"		=   esc [ 1 2 8 ~       ;;; R15 (3)

		"topwindow"			=   esc esc [ 1 1 1 ~   ;;; ESC R1 Pause
		"topfile"			=   esc esc [ 1 1 2 ~   ;;; ESC R2 PrScr & Moon+
		"markfind"			=   esc esc [ 1 1 3 ~   ;;; ESC R3 ScrLock & Moon-
		"midwindow"			=   esc esc [ 1 1 4 ~   ;;; ESC R4 [!]
		"endfile"			=   esc esc [ 1 1 5 ~   ;;; ESC R5 "/" and Top Right
		"endrange"			=   esc esc [ 1 1 7 ~   ;;; ESC R6 "*"
		"charupleftlots"	=   esc esc [ 1 1 8 ~   ;;; ESC R7 (7)
		"charuplots"		=   esc esc [ 1 1 9 ~   ;;; ESC R8 (8)
		"charuprightlots"	=   esc esc [ 1 2 0 ~   ;;; ESC R9 (9)
		"charleftlots"		=   esc esc [ 1 2 1 ~	;;; ESC R1 (4)
		"midwindow"			=   esc esc [ 1 2 3 ~   ;;; ESC R1 (5)
		"charrightlots"		=   esc esc [ 1 2 4 ~	;;; ESC R1 (6)
		"chardownleftlots"	=   esc esc [ 1 2 5 ~   ;;; ESC R1 (1)
		"chardownlots"		=   esc esc [ 1 2 6 ~	;;; ESC R1 (2)
		"chardownrightlots"	=   esc esc [ 1 2 8 ~   ;;; ESC R1 (3)

		;;; Middle upper keypad (six keys)

		"lineabove"			= esc [ 2 ~             ;;; INSERT
		"prevscreen"		= esc [ 5 ~             ;;; PAGE UP
		"nextscreen"		= esc [ 6 ~             ;;; PAGE DOWN
		"topfile"			= esc <                 ;;; HOME
		"endfile"			= esc >                 ;;; END
		
		"linebelow"			= esc esc [ 2 ~         ;;; ESC INSERT
		"ENTER xup"			= esc esc [ 5 ~         ;;; ESC PAGE UP
		"ENTER xdn"			= esc esc [ 6 ~         ;;; ESC PAGE DOWN
		"markfind"			= esc esc <             ;;; ESC HOME
		"endrange"			= esc esc >             ;;; ESC END

		;;; Optional extra
		"joinline"			= esc del				;;; ESC DEL

	endvedset;

;;; Stuff for Motif XVed
	vedsetkey('\^[[FF8D', "vedenter");			;;; ENTER
	vedsetkey('\^[[FFBE', "vedmarklo");				;;; F1
	vedsetkey('\^[\^[[FFBE', "ved_mbf");			;;; ESC F1

;;; Middle pad
	vedsetkey('\^[[FF63', "vedlineabove");		;;; Insert
	vedsetkey('\^[[FF50', "vedtopfile");		;;; Home
;;;	vedsetkey('\^[\^[[FF50', "ved????");		;;; ESC Home
	vedsetkey('\^[[FF57', "vedendfile");		;;; End
;;;	vedsetkey('\^[\^[[FF57', "ved????");		;;; ESC End
	vedsetkey('\^[[FF55', "vedprevscreen");		;;; Page up
;;;	vedsetkey('\^[\^[[FF55', "ved");		;;; ESC Page up
	vedsetkey('\^[[FF56', "vednextscreen");		;;; Page dn
;;;	vedsetkey('\^[\^[[FF56', "ved????");		;;; ESC Page dn

;;; Arrow pad
;;; 	vedsetkey('\^[[FF52', "vedscreenup");		;;; Up
;;; 	vedsetkey('\^[\^[[FF52', "vedtopfile");		;;; ESC Up
;;; 	vedsetkey('\^[[FF51', "vedscreenleft");		;;; Left
;;; 	vedsetkey('\^[\^[[FF51', "vedtextleft");	;;; ESC Left
;;; 	vedsetkey('\^[[FF54', "vedscreendown");		;;; Down
;;; 	vedsetkey('\^[\^[[FF54', "vedendfile");		;;; ESC Down
;;; 	vedsetkey('\^[[FF53', "vedtextright");		;;; Right
;;; 	vedsetkey('\^[\^[[FF53', "vedscreenright");	;;; ESC Right
	vedsetkey('\^[[FF52', "vedcharup");		;;; Up
	vedsetkey('\^[\^[[FF52', "vedtopfile");		;;; ESC Up
	vedsetkey('\^[[FF51', "vedcharleft");		;;; Left
	vedsetkey('\^[\^[[FF51', "vedtextleft");	;;; ESC Left
	vedsetkey('\^[[FF54', "vedchardown");		;;; Down
	vedsetkey('\^[\^[[FF54', "vedendfile");		;;; ESC Down
	vedsetkey('\^[[FF53', "vedcharright");		;;; Right
	vedsetkey('\^[\^[[FF53', "vedscreenright");	;;; ESC Right

	'sun_type5' -> vedkeymapname
enddefine;


endsection;

/* --- Revision History ---------------------------------------------------
--- Aaron Sloman, Aug 25 1998
	Changed to work with REDO key on Ultra5
--- Aaron Sloman, Oct 12 1997
	Changed to make middle arrow keys do small moves for consistency with
	what people normally expect
--- Aaron Sloman, Oct 13 1995
	Added a lot of extra stuff for XVED under Motif
 */
