# --- Copyright University of Sussex 1990. All rights reserved. ----------
### --- Copyright University of Birmingham 2001. All rights reserved. ------
# File:             $poplocal/local/com/poplog.sh
# Purpose:          Local Poplog initialisations
# Author:           John Williams, May  8 1990 (see revisions)
# Extended:         Aaron Sloman, 7 Oct 2001
# Documentation:    REF system
# Related Files:    $popcom/poplog.sh, $poplocal/local/com/popenv.sh
#                   also  versions for csh and tcsh users
#                   $poplocal/local/com/poplog


# To be sourced by users of sh, ksh, or bash
# (e.g. as a result of " . $popcom/poplog.sh" )

# Print out local login message, if it exists and user has not asked for
# it to be suppressed by creating ~/.hushlogin
if [ -f $poplocal/local/help/login.message -a ! -f $HOME/.hushlogin ]
then
    cat $poplocal/local/help/login.message
fi

## See if there are local extensions or alterations to the environment
## variables used by poplog, e.g. new definitions of pop_xxx to define
## commands xxx linked to basepop11

if [ -f $poplocal/local/com/popenv.sh ]
then
    . $poplocal/local/com/popenv.sh
fi

# Optional if you want to make extra commands available, e.g.
#       new symbolic links to $popsys/basepop11
# PATH=$poplocal/local/com/\:$PATH
# export PATH

# --- Revision History ---------------------------------------------------
# --- Aaron Slomn, 7 Oct 2001
#       Further reorganisation and tidying
# --- Aaron Slomn, 23 Aug 2001
#       Put in an extra test, added comments, etc.
# --- Aaron Sloman, Sep 14 1995
#       Removed some out of date stuff
