/* --- Copyright University of Birmingham 1996. All rights reserved. ------
 > File:            $poplocal/local/lib/stripfile.p
 > Purpose:         Like stripvedfile, but accepts line numbers
 > Author:          Aaron Sloman, Dec 12 1996
 > Documentation:	Below
 > Related Files:
 */

/* --- Copyright University of Sussex 1992. All rights reserved. ----------
 > File:            C.all/lib/lib/stripvedfile.p
 > Purpose:			Strip attribute control chars etc from a VED file
 > Author:          John Gibson, Mar 16 1992 (see revisions)
 > Documentation:	Self-documenting
 */

#_TERMIN_IF not(pop_runtime)

;;; USAGE:
;;;
;;;		basepop11 %noinit $poplocal/local/lib/stripfile [-f N] [-l M] [ -o <outfile> ] <file>
;;;
;;; Reads VED file <file> and outputs it as plain text to standard output
;;; (or <outfile> if -o supplied).

procedure();

	vars
		start, fin,
		infile	
		outfile;

	lvars
		procedure (repeater, consumer)
		;
	dlocal vednotabs = false, vedindentstep = 1;

	if poparglist matches ['-f' ?start '-l' ?fin '-o' ?outfile ?infile] then
	elseif poparglist matches ['-f' ?start '-l' ?fin ?infile] then
			popdevout -> outfile
	elseif poparglist matches ['-f' ?start ?infile] then
			'9999999999' -> fin;
			popdevout -> outfile
	elseif poparglist matches ['-l' ?fin ?infile] then
			'2' -> start ;
			popdevout -> outfile
	elseif poparglist matches [ ?infile] then
			false ->> start, fin;
			popdevout -> outfile
	elseif poparglist matches ['-o' ?outfile ?infile] then
			false ->> start, fin;
	else
		mishap(0,'pop11 stripfile [-f N -l M] [-o outfile] infile')
	endif;


	vedfile_line_repeater(infile) -> repeater;

	vedfile_line_consumer(outfile, 1) -> consumer;	;;; 1 = trans to plain ASCII

	if start then strnumber(start) -> start; strnumber(fin) -> fin endif;

	;;; ensure file header line is printed
	consumer(repeater());

	lvars counter = 1, line;

	until (repeater() ->> line) == termin do
		counter fi_+ 1 -> counter;
		if start then
			nextif(counter fi_< start);
			quitif(counter fi_> fin);
		endif;
		consumer(line);	
	enduntil;
	consumer(termin)
endprocedure ();


/* --- Revision History ---------------------------------------------------
--- John Gibson, Oct 21 1992
		Added #_TERMIN_IF
--- John Gibson, Oct  5 1992
		Put inside a procedure with vednotabs false etc.
 */
